<?php
class Admin extends Controller
{
    private $id_usuario;
    public function __construct()
    {
        parent::__construct();
        session_start();
        $this->id_usuario = $_SESSION['id'];
    }


    public function index()
    {

        $data['title'] = 'Panel de administración';
        $data['script'] = 'files.js';
        $data['active'] = 'recent';
        $carpetas = $this->model->getCarpetas($this->id_usuario);
        $data['archivos'] = $this->model->getArchivosRecientes($this->id_usuario);
        for ($i = 0; $i < count($carpetas); $i++) {
            $carpetas[$i]['color'] = substr(md5($carpetas[$i]['id']), 0, 6);
            $carpetas[$i]['fecha'] = time_ago(strtotime($carpetas[$i]['fecha_create']));
        }
        $data['carpetas'] = $carpetas;
        $this->views->getView('admin', 'home', $data);
    }

    function crearcarpetas()
    {
        $nombre = $_POST['nombre'];
        if (empty($nombre)) {
            $res = array('tipo' => 'warning', 'mensaje' => ' EL NOMBRE ES REQUERIDO');
        } else {
            //
            ### COMPROBAR NOMBRE###
            $verificarNombre = $this->model->getVerificar('nombre', $nombre, $this->id_usuario, 0);
            if (empty($verificarNombre)) {
                $data = $this->model->crearcarpetas($nombre, $this->id_usuario);
                if ($data > 0) {
                    $res = array('tipo' => 'success', 'mensaje' => 'Carpeta Creada');
                } else {
                    $res = array('tipo' => 'error', 'mensaje' => 'Error de creación');
                }
            } else {
                $res = array('tipo' => 'warning', 'mensaje' => 'La Carpeta ya existe');
            }
        }
        echo json_encode($res, JSON_UNESCAPED_UNICODE);
        die();
    }

    function subirarchivo()
    {
        $id_carpeta =  (empty($_POST['id_carpeta']) ? 1 : $_POST['id_carpeta']);
        $archivo = $_FILES['file'];
        $name = $archivo['name'];
        $tmp = $archivo['tmp_name'];
        $tipo = $archivo['type'];
        $data = $this->model->subirArchivo($name, $tipo, $id_carpeta);
        if ($data > 0) {
            $destino = 'Assets/archivos';
            if (!file_exists($destino)) {
                mkdir($destino);
            }
            $carpeta = $destino . '/' . $id_carpeta;
            if (!file_exists($carpeta)) {
                mkdir($carpeta);
            }
            move_uploaded_file($tmp, $carpeta . '/' . $name);
            $res = array('tipo' => 'success', 'mensaje' => 'Archivo Subido');
        } else {
            $res = array('tipo' => 'error', 'mensaje' => 'Error al subir el archivo');
        }
        echo json_encode($res, JSON_UNESCAPED_UNICODE);
        die();
    }

    function ver($id_carpeta)
    {
        $data['title'] = 'Listado de archivos';
        // $data['script'] = 'files.js';
        $data['archivos'] = $this->model->getArchivos($id_carpeta, $this->id_usuario);
        $this->views->getView('admin', 'archivos', $data);
    }
}
